package nl.tue.astar.util;

import nl.tue.astar.Record;

public interface FastLookupPriorityQueue {

	public boolean isEmpty();

	/**
	 * Checks if the queue contains a record pointing to the same state as the
	 * given record. If so, it returns the cost so far of that record,
	 * otherwise, it returns -1
	 * 
	 * @param newRec
	 * @return
	 */
	public int contains(Record newRec);

	public Record peek();

	public int size();

	public Record poll();

	public boolean add(Record newE);

}